Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/iniphysiq_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/iniphysiq_mod.F90	(revision 3315)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/iniphysiq_mod.F90	(revision 3316)
@@ -3,5 +3,5 @@
 CONTAINS
 
-subroutine iniphysiq(filename,ii,jj,nlayer,               &
+subroutine iniphysiq(ii,jj,nlayer,                        &
                      nbp, communicator,                   &
                      punjours, pdayref,ptimestep,         &
@@ -32,5 +32,4 @@
 include "iniprint.h"
 
-character(*), intent(in) :: filename ! Name of the "startfi.nc" file
 real,intent(in) :: prad ! radius of the planet (m)
 real,intent(in) :: pg ! gravitational acceleration (m/s2)
@@ -72,8 +71,8 @@
 !$OMP PARALLEL COPYIN(day_ini,day_end,hour_ini)
 
-call phys_state_var_init(filename,klon_omp,nlayer,nqtot,tname, &
-                         day_ini,day_end,hour_ini,             &
-                         punjours,ptimestep,                   &
-                         prad,pg,pr,pcpp,                      &
+call phys_state_var_init(klon_omp,nlayer,nqtot,tname, &
+                         day_ini,day_end,hour_ini,    &
+                         punjours,ptimestep,          &
+                         prad,pg,pr,pcpp,             &
                          nqperes,nqfils) ! MVals: variables isotopes
 call ini_fillgeom(klon_omp,latitude,longitude,cell_area)
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/newstart.F
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/newstart.F	(revision 3315)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/newstart.F	(revision 3316)
@@ -391,5 +391,5 @@
 
 ! Initialize the physics
-         CALL iniphysiq('startfi.nc',iim,jjm,llm,
+         CALL iniphysiq(iim,jjm,llm,
      &                  (jjm-1)*iim+2,comm_lmdz,
      &                  daysec,day_ini,dtphys,
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/nogcm.F90
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/nogcm.F90	(revision 3315)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/nogcm.F90	(revision 3316)
@@ -458,9 +458,9 @@
      ! Physics:
 #ifdef CPP_PHYS
-     CALL iniphysiq('startfi.nc',iim,jjm,llm,             &
-          (jjm-1)*iim+2,comm_lmdz,                        &
-          daysec,day_ini,dtphys/nsplit_phys,              &
-          rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp, &
-          iflag_phys)
+     CALL iniphysiq(iim,jjm,llm,              &
+          (jjm-1)*iim+2,comm_lmdz,            &
+          daysec,day_ini,dtphys/nsplit_phys,  &
+          rlatu,rlatv,rlonu,rlonv,aire,cu,cv, &
+          rad,g,r,cpp,iflag_phys)
 #endif
   ENDIF ! of IF ((iflag_phys==1).or.(iflag_phys>=100))
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/start2archive.F
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/start2archive.F	(revision 3315)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/start2archive.F	(revision 3316)
@@ -160,7 +160,5 @@
 
 ! Initialize the physics
-      fichnom = 'startfi.nc'
-
-         CALL iniphysiq(fichnom,iim,jjm,llm,
+         CALL iniphysiq(iim,jjm,llm,
      &                  (jjm-1)*iim+2,comm_lmdz,
      &                  daysec,day_ini,dtphys,
@@ -168,4 +166,5 @@
      &                  aire,cu,cv,rad,g,r,cpp,1)
 
+      fichnom = 'startfi.nc'
       Lmodif=0
 
Index: trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/start2archive_SSO.F
===================================================================
--- trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/start2archive_SSO.F	(revision 3315)
+++ trunk/LMDZ.MARS/libf/dynphy_lonlat/phymars/start2archive_SSO.F	(revision 3316)
@@ -173,7 +173,5 @@
 
 ! Initialize the physics
-      fichnom = 'startfi.nc'
-
-         CALL iniphysiq(fichnom,iim,jjm,llm,
+         CALL iniphysiq(iim,jjm,llm,
      &                  (jjm-1)*iim+2,comm_lmdz,
      &                  daysec,day_ini,dtphys,
@@ -181,4 +179,5 @@
      &                  aire,cu,cv,rad,g,r,cpp,1)
 
+      fichnom = 'startfi.nc'
       Lmodif=0
 
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/init_testphys1d_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/init_testphys1d_mod.F90	(revision 3315)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/init_testphys1d_mod.F90	(revision 3316)
@@ -405,5 +405,5 @@
 ! call init_vertical_layers(nlayer,preff,scaleheight,ap,bp,aps,bps,presnivs,pseudoalt)
 call init_dimphy(1,nlayer) ! Initialize dimphy module
-call phys_state_var_init(startfiname,1,llm,nq,tname,day0,dayn,time,daysec,dttestphys,rad,g,r,cpp,nqperes,nqfils) ! MVals: variables isotopes
+call phys_state_var_init(1,llm,nq,tname,day0,dayn,time,daysec,dttestphys,rad,g,r,cpp,nqperes,nqfils) ! MVals: variables isotopes
 call ini_fillgeom(1,latitude,longitude,(/1.0/))
 call conf_phys(1,llm,nq)
Index: trunk/LMDZ.MARS/libf/phymars/phyetat0_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/phyetat0_mod.F90	(revision 3315)
+++ trunk/LMDZ.MARS/libf/phymars/phyetat0_mod.F90	(revision 3316)
@@ -28,9 +28,9 @@
 use dust_rad_adjust_mod, only: dust_rad_adjust_prev,dust_rad_adjust_next
 use dust_param_mod,      only: dustscaling_mode
-USE ioipsl_getin_p_mod,  only: getin_p
+use ioipsl_getin_p_mod,  only: getin_p
 use comsoil_h,           only: flux_geo
-USE comslope_mod,        only: nslope, major_slope
-USE paleoclimate_mod,    only: paleoclimate, h2o_ice_depth, lag_co2_ice, d_coef
-USE comcstfi_h,          only: pi
+use comslope_mod,        only: nslope, major_slope
+use paleoclimate_mod,    only: paleoclimate, h2o_ice_depth, lag_co2_ice, d_coef
+use comcstfi_h,          only: pi
 use geometry_mod,        only: latitude
 
@@ -51,6 +51,6 @@
 !                        flag: startphy_file
 !======================================================================
-  INTEGER nbsrf !Mars nbsrf a 1 au lieu de 4
-  PARAMETER (nbsrf=1) ! nombre de sous-fractions pour une maille
+integer nbsrf !Mars nbsrf a 1 au lieu de 4
+parameter (nbsrf=1) ! nombre de sous-fractions pour une maille
 !======================================================================
 !  Arguments:
@@ -91,11 +91,11 @@
 integer :: ig, iq, lmax, islope, nid, nvarid, ierr, i, nsrf, nqold
 ! integer :: isoil
-! INTEGER :: length
-! PARAMETER (length=100)
-CHARACTER(7) :: str7
-CHARACTER(2) :: str2
-CHARACTER(1) :: yes
-
-REAL :: p_rad, p_omeg, p_g, p_mugaz, p_daysec
+! integer :: length
+! parameter (length=100)
+character(7) :: str7
+character(2) :: str2
+character(1) :: yes
+
+real :: p_rad, p_omeg, p_g, p_mugaz, p_daysec
 
 ! flag which identifies if 'startfi.nc' file is using old names (qsurf01,...)
@@ -105,25 +105,25 @@
 
 ! specific for time
-REAL, ALLOCATABLE :: time(:)   ! times stored in start
-INTEGER           :: timelen   ! number of times stored in the file
-INTEGER           :: indextime ! index of selected time
-
-INTEGER :: edges(3),corner(3)
-LOGICAL :: found
-REAL    :: timestart  ! to pick which initial state to start from
-REAL    :: surfemis   ! constant emissivity when no startfi
-REAL    :: surfalbedo ! constant albedo when no startfi
-REAL    :: watercaptag_tmp(ngrid)
+real, allocatable :: time(:)   ! times stored in start
+integer           :: timelen   ! number of times stored in the file
+integer           :: indextime ! index of selected time
+
+integer :: edges(3),corner(3)
+logical :: found
+real    :: timestart  ! to pick which initial state to start from
+real    :: surfemis   ! constant emissivity when no startfi
+real    :: surfalbedo ! constant albedo when no startfi
+real    :: watercaptag_tmp(ngrid)
 
 ! Sub-grid scale slopes
-LOGICAL           :: startphy_slope ! to be retrocompatible and add the nslope dimension
-REAL, ALLOCATABLE :: default_def_slope(:)
-REAL              :: sum_dist
-REAL              :: current_max !var to find max distrib slope
+logical           :: startphy_slope ! to be retrocompatible and add the nslope dimension
+real, allocatable :: default_def_slope(:)
+real              :: sum_dist
+real              :: current_max !var to find max distrib slope
 
 ! Variables for CO2 index
-INTEGER :: igcm_co2_tmp
-
-CHARACTER(5) :: modname="phyetat0"
+integer :: igcm_co2_tmp
+
+character(5) :: modname="phyetat0"
 !======================================================================
 
@@ -870,19 +870,19 @@
 subroutine ini_tab_controle_dyn_xios(idayref)
 
-USE comcstfi_h,        only: g, mugaz, omeg, rad, rcp
-USE time_phylmdz_mod,  ONLY: hour_ini, daysec, dtphys
-USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev
-
-IMPLICIT NONE
-
-INTEGER*4, intent(in) :: idayref ! date (initial date for this run)
-
-INTEGER :: length,l
+use comcstfi_h,        only: g, mugaz, omeg, rad, rcp
+use time_phylmdz_mod,  only: hour_ini, daysec, dtphys
+use mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, nbp_lev
+
+implicit none
+
+integer*4, intent(in) :: idayref ! date (initial date for this run)
+
+integer :: length, l
 parameter (length = 100)
-REAL    :: tab_cntrl(length) ! run parameters are stored in this array
-
-DO l=1,length
-    tab_cntrl(l)=0.
-ENDDO
+real    :: tab_cntrl(length) ! run parameters are stored in this array
+
+do l = 1,length
+    tab_cntrl(l) = 0.
+enddo
 tab_cntrl(1)  = real(nbp_lon)
 tab_cntrl(2)  = real(nbp_lat-1)
Index: trunk/LMDZ.MARS/libf/phymars/phys_state_var_init_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/phys_state_var_init_mod.F90	(revision 3315)
+++ trunk/LMDZ.MARS/libf/phymars/phys_state_var_init_mod.F90	(revision 3316)
@@ -3,5 +3,5 @@
 CONTAINS
 
-      SUBROUTINE phys_state_var_init(filename,ngrid,nlayer,nq,tname, &
+      SUBROUTINE phys_state_var_init(ngrid,nlayer,nq,tname, &
                                      day_ini,day_end,hour_ini,pdaysec,ptimestep, &
                                      prad,pg,pr,pcpp, &
@@ -69,17 +69,18 @@
 
       IMPLICIT NONE
-
-      character(*), intent(in) :: filename ! Name of the "startfi.nc" file
-      integer,      intent(IN) :: ngrid,nlayer,nq
-      character(*), intent(IN) :: tname(nq)
-      integer,      intent(IN) :: day_ini, day_end
-      real,         intent(IN) :: hour_ini
-      real,         intent(IN) :: pdaysec, ptimestep, prad, pg, pr, pcpp
+      
+      integer,      intent(in) :: ngrid, nlayer, nq
+      character(*), intent(in) :: tname(nq)
+      integer,      intent(in) :: day_ini, day_end
+      real,         intent(in) :: hour_ini
+      real,         intent(in) :: pdaysec, ptimestep, prad, pg, pr, pcpp
 !MVals isotopes
       integer,      intent(in) :: dyn_nqperes
       integer,      intent(in) :: dyn_nqfils(nq)
-      integer :: ncid, status, nslope_dim_id
-      integer :: nslope_read
+      character(10) :: filename  ! name of the startfi.nc
+      integer       :: ncid, status, nslope_dim_id
+      integer       :: nslope_read
 
+      filename = "startfi.nc"
       if(is_master) then
         status = nf90_open(filename, nf90_nowrite, ncid)